module jp.ku6.windows.directx.d3dcompiler;

import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.directx.d3d10shader;
import jp.ku6.windows.directx.d3d10misc;
import jp.ku6.windows.directx.d3d10effect;

immutable wstring D3DCOMPILER_DLL_W = "d3dcompiler_42.dll\0"w;
immutable string  D3DCOMPILER_DLL_A = "d3dcompiler_42.dll\0";

version (UNICODE)
{
	alias D3DCOMPILER_DLL_W    D3DCOMPILER_DLL;
}
else
{
	alias D3DCOMPILER_DLL_A    D3DCOMPILER_DLL;
}

alias D3D10_SHADER_MACRO D3D_SHADER_MACRO;
alias D3D10_INCLUDE_TYPE D3D_INCLUDE_TYPE;
alias ID3D10Blob ID3DBlob;
alias ID3DBlob LPD3DBLOB;
alias ID3D10Include ID3DInclude;
alias ID3DInclude LPD3DINCLUDE;

extern (Windows)
{
	alias HRESULT function(LPCVOID pSrcData, SIZE_T SrcDataSize, LPCSTR pFileName, const(D3D10_SHADER_MACRO)* pDefines, LPD3D10INCLUDE pInclude, LPCSTR pEntrypoint, LPCSTR pTarget, UINT Flags1, UINT Flags2, LPD3DBLOB* ppCode, LPD3DBLOB* ppErrorMsgs) D3DCompileFunction;
	alias HRESULT function(LPCVOID pSrcData, SIZE_T SrcDataSize, LPCSTR pFileName, const(D3D10_SHADER_MACRO)* pDefines, LPD3D10INCLUDE pInclude, LPD3DBLOB* ppCodeText, LPD3DBLOB* ppErrorMsgs) D3DPreprocessFunction;

	alias HRESULT function(LPCVOID pSrcData, SIZE_T SrcDataSize, LPD3DBLOB* ppDebugInfo) D3DGetDebugInfoFunction;
	alias HRESULT function(LPCVOID pSrcData, SIZE_T SrcDataSize, REFIID pInterface, void** ppReflector) D3DReflectFunction;
}

immutable uint D3D_DISASM_ENABLE_COLOR_CODE            = 0x00000001;
immutable uint D3D_DISASM_ENABLE_DEFAULT_VALUE_PRINTS  = 0x00000002;
immutable uint D3D_DISASM_ENABLE_INSTRUCTION_NUMBERING = 0x00000004;
immutable uint D3D_DISASM_ENABLE_INSTRUCTION_CYCLE     = 0x00000008;

extern (Windows)
{
	alias HRESULT function(LPCVOID pSrcData, SIZE_T SrcDataSize, UINT Flags, LPCSTR szComments, LPD3DBLOB* ppDisassembly) D3DDisassembleFunction;

	alias HRESULT function(ID3D10Effect pEffect, UINT Flags, LPD3DBLOB* ppDisassembly) D3DDisassemble10EffectFunction;
	alias HRESULT function(LPCVOID pSrcData, SIZE_T SrcDataSize, LPD3DBLOB* ppSignatureBlob) D3DGetInputSignatureBlobFunction;
	alias HRESULT function(LPCVOID pSrcData, SIZE_T SrcDataSize, LPD3DBLOB* ppSignatureBlob) D3DGetOutputSignatureBlobFunction;
	alias HRESULT function(LPCVOID pSrcData, SIZE_T SrcDataSize, LPD3DBLOB* ppSignatureBlob) D3DGetInputAndOutputSignatureBlobFunction;
}

enum D3DCOMPILER_STRIP_FLAGS
{
    D3DCOMPILER_STRIP_REFLECTION_DATA = 1,
    D3DCOMPILER_STRIP_DEBUG_INFO      = 2,
    D3DCOMPILER_STRIP_TEST_BLOBS      = 4,
    D3DCOMPILER_STRIP_FORCE_DWORD     = 0x7fffffff,
}

extern (Windows)
{
	alias HRESULT function(LPCVOID pShaderBytecode, SIZE_T BytecodeLength, UINT uStripFlags, LPD3DBLOB* ppStrippedBlob) D3DStripShaderFunction;
}

